/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ds.trans.example3.facade.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import rs.ds.trans.example3.domen.City;
import rs.ds.trans.example3.domen.Company;
import rs.ds.trans.example3.facade.CoreFacade;
import rs.ds.trans.example3.service.CityService;
import rs.ds.trans.example3.service.CompanyService;

/**
 *
 * @author user
 */
@Component
@Transactional(propagation = Propagation.REQUIRES_NEW)
public class CoreFacadeImpl implements CoreFacade {

    @Autowired
    private CityService cityService;
    @Autowired
    private CompanyService companyService;

    @Override
    public List<City> findAllCities() {
        return cityService.findAll();
    }

    @Override
    public City saveCity(City city) {
        return cityService.saveCity(city);
    }

    @Override
   
    public Company saveCompany(String name, Long ptt) throws Exception {
        City city = cityService.findByPtt(ptt);

        if (city != null) {
            Company company = new Company();
            company.setName(name);
            company.setPtt(city);
            return companyService.saveCompany(company);
        }
        throw new Exception("Company can not be saved! City does not exist!");

    }

    @Override
    public Company saveCompany(String companyName, Long ptt, String cityName) throws Exception {
        try {
            City searchCity = cityService.findByPtt(ptt);

            if (searchCity == null) {
                cityService.saveCity(new City(ptt, cityName));
            }

            searchCity = cityService.findByPtt(ptt);

            Company company = new Company();
            company.setName(companyName);
            company.setPtt(searchCity);

            return companyService.saveCompany(company);
        } catch (Exception e) {
            throw e;
        }
    }

}
